﻿@{
    var gameStatus = Helper.CalculateGameStatus(values);
    string status;
    if (gameStatus == GameStatus.X_wins)
    {
        status = "Game Finished! Winner: X";
    }
    else if (gameStatus == GameStatus.O_wins)
    {
        status = "Game Finished! Winner: O";
    }
    else if (gameStatus == GameStatus.Draw)
    {
        status = "Game Finished! Draw !";
    }
    else
    {
        char nextPlayer = xIsNext ? 'X' : 'O';
        status = $"Next player: {nextPlayer}";
    }
    <h3>@status</h3>
}
<div class="board">
    @for (int i = 0; i < 9; i++)
    {
        int squareNumber = i;
        <Square @key=squareNumber
                value=values[squareNumber]
                ClickHandler="@(() => HandleClick(squareNumber))" />
    }
</div>
<button class="btn btn-primary" @onclick="PlayAgainHandler">
    New game
</button>

@code {
    private bool xIsNext;
    private char[] values = new char[9];

    protected override void OnInitialized()
    {
        InitState();
    }

    private void PlayAgainHandler()
    {
        InitState();
    }

    private void InitState()
    {
        values = new char[9]
        {
        ' ', ' ', ' ',
        ' ', ' ', ' ',
        ' ', ' ', ' '
        };
        xIsNext = true;
    }
    private void HandleClick(int i)
    {
        if (values[i] != ' ')
        {
            return;
        }
        bool isGameFinished = Helper.CalculateGameStatus(values) != GameStatus.NotYetFiniched;
        if (isGameFinished)
        {
            return;
        }

        bool xToPlay = xIsNext;
        values[i] = xToPlay ? 'X' : 'O';
        xIsNext = !xToPlay;
    }
}

<style scoped>
    .board {
        display: grid;
        grid-template-columns: auto auto auto;
        width: 180px;
        height: 180px;
    }
    button {
        margin: 10px;
    }
</style>